#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
extern int yyparse(void);
#define YYPREFIX "yy"
#line 2 "user.y"
/*
    mmorph, MULTEXT morphology tool
    Version 2.3, October 1995
    Copyright (c) 1994,1995 ISSCO/SUISSETRA, Geneva, Switzerland
    Dominique Petitpierre, <petitp@divsun.unige.ch>
*/
#include "user.h"
#include "parse.h"

s_symbol	*defined_symbol;
static s_symbol	*largest_type_sym;
static t_card		 largest_type_card;
e_symbol_kind    defined_kind;
static s_symbol_set	*value_set;
static s_symbol_set	*variable_set;
static t_boolean	 variable_allowed;
static s_symbol	*current_attribute;
static s_type		*current_type;
static s_rule		*current_rule;
static s_tfs		*current_tfs;
static s_tfs		*common_tfs;
static s_chain		*current_chain;
static s_chain		*affix_tree_chain;
static int		 var_map_card;
static t_letter 	 *current_string;
static t_letter	 *current_base_form;
e_symbol_kind    current_letter_kind;
static s_pair		*current_pair;
static t_flag		 class_flags;
static t_flag		 current_pair_flags;
static int		 current_pair_width;
static s_bitmap	 *current_class;
static s_symbol	  fake_symbol;	/* used for pointing defined_symbol to */
static s_spell_instance *current_spell;
static s_bitmap	 *current_lexical_set;
static int		 current_pattern_length;
static s_chain		 *current_pattern;
static t_boolean	 within_focus;
static t_boolean	 has_concat_pos;

#define LETTER_STRING_SIZE_MAX	128
static t_letter	letter_string[LETTER_STRING_SIZE_MAX]; /* temp storage */
static int		letter_string_size; /* size of data in letter_string */
#line 47 "user.y"
typedef union {
    t_str	string;
    s_symbol	*symbol;
    s_chain	*chain;
    t_value	value;
    s_tfs	*tfs;
    s_var_map	*var_map;
    t_letter	*letter_string;
    s_pair	*pair;
    } YYSTYPE;
#line 68 "y.tab.c"
#define ANY 257
#define BAR 258
#define BIARROW 259
#define WORDBOUNDARY 260
#define CONTEXTBOUNDARY 261
#define CONCATBOUNDARY 262
#define MORPHEMEBOUNDARY 263
#define DOLLAR 264
#define EQUAL 265
#define LANGLE 266
#define LARROW 267
#define LBRA 268
#define NOTEQUAL 269
#define RANGLE 270
#define RARROW 271
#define RBRA 272
#define COERCEARROW 273
#define COLON 274
#define SLASH 275
#define ALPHABETS 276
#define ATTRIBUTES 277
#define CLASSES 278
#define GRAMMAR 279
#define LEXICON 280
#define PAIRS 281
#define SPELLING 282
#define TYPES 283
#define DNAME 284
#define NAME 285
#define STRING 286
#define SNAME 287
#define TNAME 288
#define LSTRING 289
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,   26,   33,   35,    1,   37,   27,   38,   40,   42,
   42,   43,    3,    2,   28,   44,   46,   48,   48,   48,
   49,   12,   23,   47,   11,   10,   15,   17,   18,   18,
   18,   19,   51,    6,    6,    9,    5,    8,   50,   50,
   50,   50,   13,   34,   34,   36,   36,   39,   39,   45,
   45,   14,   14,    7,    7,   41,   41,   31,   31,   52,
   54,   55,   53,   53,   57,   59,   58,   56,   56,   56,
   16,   16,   61,   61,   60,   60,   62,   62,   62,   62,
   32,   32,   63,   63,   64,   66,   67,   68,   69,   69,
   70,   72,   72,   71,   65,   65,   25,   73,   74,   75,
   77,   76,   76,   78,   78,   30,   30,   79,   80,   80,
   81,   82,   83,   83,   84,   84,   24,   24,    4,   21,
   22,   20,   20,   20,   20,   85,   85,   29,   29,   86,
   87,   87,   88,   89,   90,   90,   91,   91,
};
short yylen[] = {                                         2,
    8,    2,    1,    3,    1,    1,    2,    1,    4,    2,
    0,    1,    1,    1,    2,    1,    3,    3,    1,    1,
    1,    1,    1,    1,    2,    1,    3,    2,    1,    3,
    4,    1,    1,    2,    2,    2,    1,    2,    1,    2,
    2,    2,    2,    2,    1,    2,    1,    2,    1,    2,
    1,    2,    0,    2,    0,    2,    1,    2,    0,    1,
    7,    1,    2,    1,    1,    1,    3,    1,    1,    1,
    2,    0,    2,    1,    1,    0,    1,    1,    1,    1,
    1,    0,    3,    2,    1,    1,    2,    1,    2,    1,
    2,    2,    0,    1,    2,    0,    2,    1,    6,    1,
    1,    2,    1,    1,    1,    2,    0,    1,    2,    1,
    3,    1,    2,    1,    3,    1,    3,    1,    1,    1,
    1,    3,    1,    1,    1,    2,    0,    2,    0,    1,
    2,    1,    3,    1,    2,    1,    1,    1,
};
short yydefred[] = {                                      0,
   98,    0,    0,    0,    3,    0,    0,  100,   97,    0,
    8,    0,    0,    5,    0,    0,   45,    0,   16,    0,
    0,   13,    0,    0,   49,    0,   44,  104,  105,    0,
  103,  130,    0,    0,   24,    0,   51,    0,    0,   48,
    6,    0,   47,  101,    0,  102,  108,    0,    0,  134,
    0,  132,    0,   50,    0,   14,   57,    0,   46,    0,
   60,    0,    0,  112,    0,  110,    0,  131,    0,   26,
   23,    0,    0,    0,   19,    0,   17,   12,   56,    9,
    0,    0,   86,    1,    0,   96,   62,    0,   64,    0,
  109,    0,  137,  138,    0,  136,   53,   25,   21,    0,
   43,    0,   85,   96,    0,   63,    0,  125,  127,    0,
  123,  116,  120,    0,    0,  114,  135,    0,   22,    0,
    0,   18,    0,   88,   95,    0,   69,   68,   70,    0,
    0,    0,  113,   27,    0,   52,   40,   42,   41,   94,
    0,   90,    0,   79,   77,   78,  118,    0,   80,    0,
   65,    0,   74,  122,  126,  124,  121,  115,    0,    0,
   33,   28,   29,   89,    0,   91,    0,    0,    0,   73,
    0,   37,   55,   35,   34,   92,  117,    0,   72,   66,
   32,    0,    0,   67,    0,    0,   31,    0,   54,   71,
   38,
};
short yydgoto[] = {                                       2,
   15,   57,   23,  147,  173,  161,  183,  189,  174,   72,
  119,   74,   75,  118,   98,  185,  136,  162,  182,  113,
  148,  158,   76,  149,    3,    6,   12,   20,   33,   48,
   62,   84,    7,   16,   17,   42,   43,   13,   24,   25,
   58,   80,   81,   21,   36,   37,   38,   77,  100,  122,
  163,   63,   88,   89,   90,  130,  150,  169,  179,  151,
  152,  153,   85,  104,  105,   86,  125,  126,  141,  142,
  143,  166,    4,    9,   10,   30,   45,   31,   49,   65,
   66,   67,  115,  116,  131,   34,   51,   52,   53,   95,
   96,
};
short yysindex[] = {                                   -259,
    0,    0, -255, -225,    0, -187, -209,    0,    0, -173,
    0, -175, -179,    0, -168, -209,    0, -221,    0, -171,
 -176,    0, -165, -179,    0, -174,    0,    0,    0, -192,
    0,    0, -169, -170,    0, -176,    0, -164, -172,    0,
    0, -174,    0,    0, -159,    0,    0, -166, -167,    0,
 -170,    0, -156,    0, -191,    0,    0, -249,    0, -221,
    0, -161, -163,    0, -167,    0, -154,    0, -186,    0,
    0, -146,    0, -144,    0, -162,    0,    0,    0,    0,
 -172, -221,    0,    0, -155,    0,    0, -163,    0, -150,
    0, -200,    0,    0, -186,    0,    0,    0,    0, -191,
    0, -172,    0,    0, -162,    0, -183,    0,    0,    0,
    0,    0,    0, -148, -200,    0,    0, -260,    0, -191,
 -162,    0, -162,    0,    0, -160,    0,    0,    0, -218,
 -208, -194,    0,    0, -185,    0,    0,    0,    0,    0,
 -160,    0, -134,    0,    0,    0,    0, -147,    0, -129,
    0, -218,    0,    0,    0,    0,    0,    0, -258, -152,
    0,    0,    0,    0, -153,    0, -194, -218, -218,    0,
 -151,    0,    0,    0,    0,    0,    0, -229,    0,    0,
    0, -182, -123,    0, -162, -152,    0, -152,    0,    0,
    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -145,    0,    0,    0,   46,
    0,    0,    0, -142,    0,    0,    0,    0,    0,    0,
    0,    0,   52,    0,    0,   43,    0,    0,    0,    0,
    0, -181,    0,    0,    0,    0,    0,    2,    0,    0,
   49,    0,    0,    0,    0,    0,    0, -268,    0,    0,
    0,  139,    0,    0,   53,    0,    0,    0,    0,    0,
    0,    0,   30,    0,    0,    0,    0,    0,    0,    0,
    0, -136,    0,    0,  140,    0,    0,   19,    0,    0,
    0,    0,    0,    0,   35,    0,    0,    0,    0,    0,
    0, -266,    0,    0,   20,    0,    0,    0,    0,    1,
    0,    0,    0,    0,   38,    0,    0,    0,    0,   23,
    0,    0,   26,    0,    0,    0,    0,    0,    0, -119,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    8,    0,    4,    0,    0,    0,    0,    0,    0,    0,
    0,    7,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   14,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -203, -199,    0,   29,    0,    0,    0,    0,    0,
    0,
};
short yygindex[] = {                                      0,
    0,  -48,    0,  -68,  -45,    0,    0,    0,  -16,    0,
  -55,  -42,  -39,    0,    0,    0,    0,    0,    0, -127,
  -41,  -22,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  130,    0,  105,    0,    0,  124,
   68,    0,    0,    0,    0,  114,    0,    0,    0,    0,
  -31,    0,    0,   64,    0,    0,    0,    0,    0,  -15,
  -13, -137,    0,    0,   54,    0,    0,    0,    0,   12,
    0,    0,    0,    0,    0,   96,    0,  -27,    0,    0,
   92,    0,    0,   44,    0,    0,    0,  109,    0,    0,
   66,
};
#define YYTABLESIZE 335
short yytable[] = {                                      73,
  119,   59,   46,   93,  157,  171,   75,   87,   78,   79,
   11,  134,   10,   76,  170,   11,    1,   10,   58,   84,
  101,    5,   39,  112,   56,   83,  172,  108,   61,   20,
  144,  184,  145,  146,  133,   56,  109,  111,  108,  157,
  170,  144,   15,  145,  146,  129,  112,  109,  128,  124,
  114,  107,  106,   79,   46,  110,  108,  120,    8,  111,
  121,  154,  108,   28,   29,  109,  110,  124,   30,  135,
  111,  109,   36,  114,   14,  127,  155,  137,  139,  159,
  138,   30,  186,  160,  110,   36,  160,  128,  111,  129,
  156,   44,   28,   29,  111,   11,   70,   71,   93,   94,
   18,    4,    4,   19,   22,   26,   32,   35,   39,   55,
   41,   47,   56,   50,   60,   61,   64,   69,   83,   92,
   87,   97,   99,  107,  103,   70,  132,  167,  140,  190,
  165,  168,  172,  181,  188,  176,    7,    2,   82,   81,
   99,   76,  191,  175,  177,   27,   59,   40,  102,   54,
  187,  106,  164,  180,  178,   82,   91,  123,  133,   68,
  117,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  119,    0,    0,
  119,  119,  119,  119,    0,    0,  119,   75,    0,    0,
    0,    0,    0,    0,    0,  124,    0,    0,    0,    0,
  119,   59,  119,   93,  119,  119,   75,   87,  119,  119,
   75,   93,   93,   76,   75,   87,   22,   76,   58,   84,
   39,   76,   39,   39,   39,   83,   39,   20,   61,   20,
   20,   20,   61,   20,  133,  133,  133,  111,  133,  111,
   15,  111,   15,   15,   15,  129,  129,  129,  128,  128,
  128,  107,  106,  107,  106,
};
short yycheck[] = {                                      55,
    0,    0,   30,    0,  132,  264,    0,    0,  258,   58,
  279,  272,  279,    0,  152,  284,  276,  284,    0,    0,
   76,  277,    0,   92,  285,    0,  285,  257,    0,    0,
  260,  261,  262,  263,    0,  285,  266,    0,  257,  167,
  178,  260,    0,  262,  263,    0,  115,  266,    0,  105,
   92,    0,    0,  102,   82,  285,  257,  100,  284,  289,
  100,  270,  257,  285,  286,  266,  285,  123,  272,  118,
  289,  266,  272,  115,  284,  259,  285,  120,  121,  265,
  120,  285,  265,  269,  285,  285,  269,  271,  289,  273,
  285,  284,  285,  286,  289,  283,  288,  289,  285,  286,
  274,  283,  284,  279,  284,  274,  278,  284,  274,  274,
  285,  281,  285,  284,  274,  282,  284,  274,  280,  274,
  284,  268,  267,  274,  280,  288,  275,  275,  289,  185,
  265,  261,  285,  285,  258,  289,  279,  283,    0,    0,
  277,  261,  188,  160,  167,   16,   42,   24,   81,   36,
  182,   88,  141,  169,  168,   60,   65,  104,  115,   51,
   95,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,   -1,
  260,  261,  262,  263,   -1,   -1,  266,  261,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  275,   -1,   -1,   -1,   -1,
  280,  280,  282,  280,  284,  285,  280,  280,  288,  289,
  284,  288,  289,  280,  288,  288,  267,  284,  280,  280,
  278,  288,  280,  281,  282,  280,  284,  278,  280,  280,
  281,  282,  284,  284,  280,  281,  282,  280,  284,  282,
  278,  284,  280,  281,  282,  280,  281,  282,  280,  281,
  282,  280,  280,  282,  282,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 1
#endif
#define YYMAXTOKEN 289
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"ANY","BAR","BIARROW",
"WORDBOUNDARY","CONTEXTBOUNDARY","CONCATBOUNDARY","MORPHEMEBOUNDARY","DOLLAR",
"EQUAL","LANGLE","LARROW","LBRA","NOTEQUAL","RANGLE","RARROW","RBRA",
"COERCEARROW","COLON","SLASH","ALPHABETS","ATTRIBUTES","CLASSES","GRAMMAR",
"LEXICON","PAIRS","SPELLING","TYPES","DNAME","NAME","STRING","SNAME","TNAME",
"LSTRING",
};
char *yyrule[] = {
"$accept : Start",
"Start : AlphabetDecl AttDecl TypeDecl GramDecl ClassDeclOPT PairDeclOPT SpellDeclOPT LexDeclSTAR",
"AttDecl : AttHead AttDefPLUS",
"AttHead : ATTRIBUTES",
"AttDef : AttNew COLON ValNewPLUS",
"AttNew : DNAME",
"ValNew : NAME",
"TypeDecl : TypeHead TypeDefPLUS",
"TypeHead : TYPES",
"TypeDef : TypeNew COLON AttNamePLUS NoProjectAttOPTL",
"NoProjectAttOPTL : ProjSep AttNamePLUS",
"NoProjectAttOPTL :",
"ProjSep : BAR",
"TypeNew : DNAME",
"AttName : NAME",
"GramDecl : GramHead RulePLUS",
"GramHead : GRAMMAR",
"Rule : RuleNew COLON RuleBody",
"RuleBody : VarTfs Rewrite Rhs",
"RuleBody : Affix",
"RuleBody : Tfs",
"Rewrite : LARROW",
"VarTfs : Tfs",
"AffixString : LSTRING",
"RuleNew : DNAME",
"Tfs : TypeName AttSpec",
"TypeName : TNAME",
"AttSpec : LBRA AttValSTAR RBRA",
"AttVal : AttName ValSpec",
"ValSpec : ValSetSpec",
"ValSpec : EQUAL DOLLAR VarName",
"ValSpec : EQUAL DOLLAR VarName ValSetSpec",
"VarName : NAME",
"ValSetSpec : ValSet",
"ValSet : NOTEQUAL ValDisj",
"ValSet : EQUAL ValDisj",
"ValDisj : ValName ValDisjRestSTAR",
"ValName : NAME",
"ValDisjRest : BAR ValName",
"Rhs : VarTfs",
"Rhs : VarTfs VarTfs",
"Rhs : Affix VarTfs",
"Rhs : VarTfs Affix",
"Affix : AffixString Tfs",
"AttDefPLUS : AttDefPLUS AttDef",
"AttDefPLUS : AttDef",
"ValNewPLUS : ValNewPLUS ValNew",
"ValNewPLUS : ValNew",
"TypeDefPLUS : TypeDefPLUS TypeDef",
"TypeDefPLUS : TypeDef",
"RulePLUS : RulePLUS Rule",
"RulePLUS : Rule",
"AttValSTAR : AttValSTAR AttVal",
"AttValSTAR :",
"ValDisjRestSTAR : ValDisjRestSTAR ValDisjRest",
"ValDisjRestSTAR :",
"AttNamePLUS : AttNamePLUS AttName",
"AttNamePLUS : AttName",
"SpellDeclOPT : SpellHead SpellDefPLUS",
"SpellDeclOPT :",
"SpellHead : SPELLING",
"SpellDef : SpellNew COLON Arrow LeftContext Focus RightContext ConstraintSTAR",
"SpellNew : DNAME",
"SpellDefPLUS : SpellDefPLUS SpellDef",
"SpellDefPLUS : SpellDef",
"LeftContext : PatternSTAR",
"RightContext : PatternSTAR",
"Focus : CONTEXTBOUNDARY PatternPLUS CONTEXTBOUNDARY",
"Arrow : RARROW",
"Arrow : BIARROW",
"Arrow : COERCEARROW",
"ConstraintSTAR : ConstraintSTAR Tfs",
"ConstraintSTAR :",
"PatternPLUS : PatternPLUS Pattern",
"PatternPLUS : Pattern",
"PatternSTAR : PatternPLUS",
"PatternSTAR :",
"Pattern : CONCATBOUNDARY",
"Pattern : MORPHEMEBOUNDARY",
"Pattern : WORDBOUNDARY",
"Pattern : PairPattern",
"LexDeclSTAR : LexDeclPLUS",
"LexDeclSTAR :",
"LexDeclPLUS : LexDeclPLUS LexHead LexDefSTAR",
"LexDeclPLUS : FirstLexHead LexDefSTAR",
"LexHead : LEXICON",
"FirstLexHead : LEXICON",
"LexDef : CommonTfs LexicalPLUS",
"CommonTfs : Tfs",
"LexicalPLUS : LexicalPLUS Lexical",
"LexicalPLUS : Lexical",
"Lexical : LexNew BaseFormOPTL",
"BaseFormOPTL : EQUAL LSTRING",
"BaseFormOPTL :",
"LexNew : LSTRING",
"LexDefSTAR : LexDefSTAR LexDef",
"LexDefSTAR :",
"AlphabetDecl : AlphabetHead AlphabetDef",
"AlphabetHead : ALPHABETS",
"AlphabetDef : LexicalNew COLON LetterNewPLUS SurfaceNew COLON LetterNewPLUS",
"LexicalNew : DNAME",
"SurfaceNew : DNAME",
"LetterNewPLUS : LetterNewPLUS LetterNew",
"LetterNewPLUS : LetterNew",
"LetterNew : NAME",
"LetterNew : STRING",
"PairDeclOPT : PairHead PairDefPLUS",
"PairDeclOPT :",
"PairHead : PAIRS",
"PairDefPLUS : PairDefPLUS PairDef",
"PairDefPLUS : PairDef",
"PairDef : PairNew COLON PairPLUS",
"PairNew : DNAME",
"PairPLUS : PairPLUS Pair",
"PairPLUS : Pair",
"Pair : SurfSequence SLASH LexSequence",
"Pair : PairName",
"PairPattern : SurfSequence SLASH LexSequence",
"PairPattern : PairName",
"PairName : NAME",
"SurfSequence : Sequence",
"LexSequence : Sequence",
"Sequence : LANGLE LetterSTAR RANGLE",
"Sequence : LSTRING",
"Sequence : NAME",
"Sequence : ANY",
"LetterSTAR : LetterSTAR NAME",
"LetterSTAR :",
"ClassDeclOPT : ClassHead ClassDefPLUS",
"ClassDeclOPT :",
"ClassHead : CLASSES",
"ClassDefPLUS : ClassDefPLUS ClassDef",
"ClassDefPLUS : ClassDef",
"ClassDef : ClassNew COLON ClassPLUS",
"ClassNew : DNAME",
"ClassPLUS : ClassPLUS Class",
"ClassPLUS : Class",
"Class : NAME",
"Class : STRING",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse(void)
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 143 "user.y"
{

	}
break;
case 2:
#line 149 "user.y"
{
	    defined_symbol=NULL; /* end of definitions */
	    make_symbol_reference(&symbol_set[Attribute]);
	    if (debug & DEBUG_INIT)
		print_symbols_by_ref(&symbol_set[Attribute]);
	}
break;
case 3:
#line 158 "user.y"
{
	    defined_kind=Attribute;
	    crc32file_addn(&crc, (unsigned char *) "@Attributes ",
			   sizeof("@Attributes "));
	}
break;
case 4:
#line 166 "user.y"
{
	    make_symbol_reference(value_set);
	    link_attribute(value_set,yyvsp[-2].symbol);
	    defined_symbol=NULL; /* for error message */
	}
break;
case 5:
#line 174 "user.y"
{
	    yyval.symbol=*new_symbol(yyvsp[0].string,&symbol_set[Attribute]);
	    value_set=&yyval.symbol->data->attribute.value_set;
	    defined_symbol=yyval.symbol;
	    crc32file_addn(&crc, (unsigned char *) yyvsp[0].string, (int) strlen(yyvsp[0].string));
	    crc32file_add(&crc, (unsigned char) ':');
	}
break;
case 6:
#line 184 "user.y"
{
	    (void) new_symbol(yyvsp[0].string,value_set);
	    crc32file_addn(&crc, (unsigned char *) yyvsp[0].string, (int) strlen(yyvsp[0].string));
	    crc32file_add(&crc, (unsigned char) ' ');
	}
break;
case 7:
#line 192 "user.y"
{
	    defined_symbol=NULL; /* end of definitions */
	    make_symbol_reference(&symbol_set[Type]);
	    largest_type=largest_type_sym->ordinal;
	    if (debug & DEBUG_INIT)
		print_symbols_by_ref(&symbol_set[Type]);
	    /* TODO: move this to end of spelling rules
               when looking up unknown words works.
	     */
	    if (db_operation & Lookup) {
		crc32file_hash(&crc, crc_hash);
		parsing=FALSE; /* change format of fatal errors */
		tfs_table_init(db_operation, gram_file_name, db_file_name,
			       crc_hash);
		parsing=TRUE;
	    }
	    if (db_operation == Lookup)
		YYACCEPT; /* skip the rest of the file */
	}
break;
case 8:
#line 214 "user.y"
{
	    defined_kind=Type;
	    largest_type_card = 0;
	    crc32file_addn(&crc, (unsigned char *) "@Types ",
			   sizeof("@Types "));
	}
break;
case 9:
#line 223 "user.y"
{
	    if (current_type->project_card==0)
		current_type->project_card=current_type->card;
	    if (current_type->card > largest_type_card) {
		largest_type_sym = defined_symbol;
		largest_type_card = current_type->card;
	    }
	    current_type->attribute_ref=
		  (s_symbol **) new_ref((int) current_type->card,
					 map_chain,
					 (t_ptr) current_chain,
					 ref_is_item);
	    free_chain(current_chain);
	    defined_symbol=NULL; /* for error message */
	}
break;
case 10:
#line 241 "user.y"
{
		}
break;
case 11:
#line 244 "user.y"
{
		}
break;
case 12:
#line 249 "user.y"
{
	    current_type->project_card= current_type->card;
	    crc32file_add(&crc, (unsigned char) '|');
	}
break;
case 13:
#line 255 "user.y"
{
	    defined_symbol = *new_symbol(yyvsp[0].string,&symbol_set[Type]);
	    current_type = (s_type *) defined_symbol->data;
	    current_chain = NULL;
	    crc32file_addn(&crc, (unsigned char *) yyvsp[0].string, (int) strlen(yyvsp[0].string));
	    crc32file_add(&crc, (unsigned char) ':');
	}
break;
case 14:
#line 265 "user.y"
{
	    yyval.symbol=*find_symbol(yyvsp[0].string,&symbol_set[Attribute]);
	    current_attribute=yyval.symbol;
	    value_set= &((yyval.symbol)->data->attribute.value_set);
	}
break;
case 15:
#line 273 "user.y"
{
	    defined_symbol=NULL; /* end of definitions */
	    make_symbol_reference(&symbol_set[Rule]);
	    if (debug & DEBUG_INIT)
		print_symbols_by_ref(&symbol_set[Rule]);
	    if (! parse_only)
		prepare_rules();
	}
break;
case 16:
#line 284 "user.y"
{
	    defined_kind=Rule;
	    goal_card = 0;
	    /* tell tokenizer to interpret strings as lexical strings */
	    current_letter_kind=Lexical_Letter;
	    current_letter_map=lexical_letter_map;
	}
break;
case 17:
#line 294 "user.y"
{
	    defined_symbol=NULL; /* for error message */
	}
break;
case 18:
#line 300 "user.y"
{
		make_symbol_reference(variable_set);
		current_rule->instance->lhs=yyvsp[-2].tfs;
		adjust_var_map(variable_set->ref,current_rule->instance);
	    }
break;
case 19:
#line 306 "user.y"
{
		variable_set = NULL; /* no variable to handle */
		current_rule->instance->rule_kind = Lexical;
		current_rule->instance->lhs=yyvsp[0].tfs;
	    }
break;
case 20:
#line 312 "user.y"
{
		current_rule->instance->rule_kind = Goal;
		goal_card++;
		if (yyvsp[0].tfs->var_map != NULL) /* TODO catch this earlier */
		    fatal_error("variables not allowed in goal rule");
		current_rule->instance->first=yyvsp[0].tfs;
		current_rule->instance->lex= (t_letter *) "";/* empty string */
		current_rule->instance->lhs=new_tfs(yyvsp[0].tfs->type);
		fill_tfs_with_variables(current_rule->instance->lhs);
		ident_var_map(current_rule->instance->lhs);
	    }
break;
case 21:
#line 326 "user.y"
{

	    }
break;
case 22:
#line 332 "user.y"
{
		yyval.tfs=yyvsp[0].tfs;
	    }
break;
case 23:
#line 338 "user.y"
{
		variable_allowed=FALSE;
		yyval.letter_string=yyvsp[0].letter_string;
	    }
break;
case 24:
#line 345 "user.y"
{
	    defined_symbol = *new_symbol(yyvsp[0].string,&symbol_set[Rule]);
	    current_rule = (s_rule *)defined_symbol->data;
	    variable_set = &(current_rule->variable_set);
	    variable_allowed=TRUE;
	}
break;
case 25:
#line 354 "user.y"
{
	    yyval.tfs = yyvsp[-1].tfs; /* that's the tfs */
	    if (yyvsp[0].chain == NULL)
		yyval.tfs->var_map = NULL;
	    else {
		yyval.tfs->var_map = (s_var_map **) new_ref(var_map_card,
						     map_chain,
						     (t_ptr) yyvsp[0].chain,
						     ref_is_item);
		free_chain(yyvsp[0].chain);
	    }
	}
break;
case 26:
#line 369 "user.y"
{
	    s_symbol *symbol;

	    symbol = *find_symbol(yyvsp[0].string,&symbol_set[Type]);
	    current_type = (s_type *) symbol->data;
	    yyval.tfs=new_tfs(symbol->ordinal);
	    current_tfs=yyval.tfs;
	    /* fill the type feature structure with full sets */
	    fill_tfs_with_variables(yyval.tfs);
	}
break;
case 27:
#line 382 "user.y"
{
	    yyval.chain=yyvsp[-1].chain;
	}
break;
case 28:
#line 388 "user.y"
{
	    yyval.var_map=yyvsp[0].var_map;
	}
break;
case 29:
#line 394 "user.y"
{
	    yyval.var_map=NULL;
	}
break;
case 30:
#line 398 "user.y"
{
	    yyval.var_map=yyvsp[0].var_map;
	}
break;
case 31:
#line 402 "user.y"
{
	    yyval.var_map=yyvsp[-1].var_map;
	}
break;
case 32:
#line 408 "user.y"
{
	    int pos;
	    s_symbol *variable;

	    pos = reference_position((t_ptr *) current_type->attribute_ref,
			             (t_ptr) current_attribute);
	    if ( pos < 0 )
		fatal_error(
		   "attribute \"%s\" not declared for type \"%s\"",
		    current_attribute->name,
		    symbol_set[Type].ref[current_tfs->type]->name);
	    if (! variable_allowed)
		fatal_error(
		    "a variable is not allowed in this context");
	    variable = *new_symbol(yyvsp[0].string,variable_set);
	    if (variable->data->variable.attribute_link == NULL)
		variable->data->variable.attribute_link=current_attribute;
	    else
		if (variable->data->variable.attribute_link
			!= current_attribute)
		    fatal_error("variable $%s %s \"%s\" and \"%s\"",
			yyvsp[0].string,
			"is used for incompatible attributes:",
			variable->data->variable.attribute_link->name,
			current_attribute->name);
	    MY_MALLOC(yyval.var_map,s_var_map);
	    yyval.var_map->foreign_index = (t_index) variable->ordinal;
	    yyval.var_map->local_index = (t_index) pos;
	}
break;
case 33:
#line 440 "user.y"
{
	    int pos;

	    pos = reference_position((t_ptr *) current_type->attribute_ref,
			             (t_ptr) current_attribute);
	    if ( pos < 0 )
		fatal_error(
		   "attribute \"%s\" not declared for type \"%s\"",
		    current_attribute->name,
		    symbol_set[Type].ref[current_tfs->type]->name);
	    current_tfs->att_list[pos] &= yyvsp[0].value;
	    if (current_tfs->att_list[pos] == NO_BITS)
		fatal_error("value set complement for \"%s\" is empty",
			    current_attribute->name);
	}
break;
case 34:
#line 457 "user.y"
{
	    yyval.value = ~ (yyvsp[0].value);
	    if (yyval.value == NO_BITS)
	        /* occurs only when there is MAXVAL values for attribute */
		fatal_error("value set complement is empty");
	}
break;
case 35:
#line 464 "user.y"
{
	    yyval.value = yyvsp[0].value;
	}
break;
case 36:
#line 470 "user.y"
{
	    yyval.value = (yyvsp[-1].value | yyvsp[0].value);
	}
break;
case 37:
#line 476 "user.y"
{
	    
	    yyval.value = BIT_N((*find_symbol(yyvsp[0].string,value_set))->ordinal);
	}
break;
case 38:
#line 483 "user.y"
{
	    yyval.value = yyvsp[0].value;
	}
break;
case 39:
#line 489 "user.y"
{
	    current_rule->instance->rule_kind=Unary;
	    current_rule->instance->first=yyvsp[0].tfs;
	    current_rule->instance->second=NULL;
	}
break;
case 40:
#line 495 "user.y"
{
	    current_rule->instance->rule_kind=Binary;
	    current_rule->instance->first=yyvsp[-1].tfs;
	    current_rule->instance->second=yyvsp[0].tfs;
	}
break;
case 41:
#line 501 "user.y"
{
	    current_rule->instance->rule_kind=Prefix;
	    current_rule->instance->first=yyvsp[0].tfs;
	    current_rule->instance->second=yyvsp[-1].tfs;
	}
break;
case 42:
#line 507 "user.y"
{
	    current_rule->instance->rule_kind=Suffix;
	    current_rule->instance->first=yyvsp[-1].tfs;
	    current_rule->instance->second=yyvsp[0].tfs;
	}
break;
case 43:
#line 515 "user.y"
{
	    /* affix tfs cannot have variables; see adjust_var_map() */
	    current_rule->instance->lex=yyvsp[-1].letter_string;
	    current_rule->instance->lex_length=strlen((char *) yyvsp[-1].letter_string);
	    yyval.tfs=yyvsp[0].tfs;
	    variable_allowed = TRUE; /* useful only for prefix */
	}
break;
case 44:
#line 524 "user.y"
{

	}
break;
case 45:
#line 528 "user.y"
{

	}
break;
case 46:
#line 534 "user.y"
{

	}
break;
case 47:
#line 538 "user.y"
{

	}
break;
case 48:
#line 544 "user.y"
{

	}
break;
case 49:
#line 548 "user.y"
{

	}
break;
case 50:
#line 554 "user.y"
{

	}
break;
case 51:
#line 558 "user.y"
{

	}
break;
case 52:
#line 564 "user.y"
{
	    var_map_card++;
	    if (yyvsp[0].var_map != NULL)
	        yyval.chain = insert_chain_link(yyvsp[-1].chain, (t_ptr) yyvsp[0].var_map);
	}
break;
case 53:
#line 570 "user.y"
{
	    var_map_card=0;
	    yyval.chain=NULL;
	}
break;
case 54:
#line 577 "user.y"
{
	    yyval.value = ( yyvsp[-1].value | yyvsp[0].value );
	}
break;
case 55:
#line 581 "user.y"
{
	    yyval.value = 0L;
	}
break;
case 56:
#line 587 "user.y"
{
	    current_type->card++;
	    current_chain=insert_chain_link(current_chain, (t_ptr) yyvsp[0].symbol);
	    crc32file_addn(&crc, (unsigned char *) yyvsp[0].symbol->name,
			   (int) strlen(yyvsp[0].symbol->name));
	    crc32file_add(&crc, (unsigned char) ' ');
	}
break;
case 57:
#line 595 "user.y"
{
	    current_type->card++;
	    current_chain=insert_chain_link(current_chain, (t_ptr) yyvsp[0].symbol);
	    crc32file_addn(&crc, (unsigned char *) yyvsp[0].symbol->name,
			   (int) strlen(yyvsp[0].symbol->name));
	    crc32file_add(&crc, (unsigned char) ' ');
	}
break;
case 58:
#line 605 "user.y"
{
	    defined_symbol=NULL; /* end of definitions */
	    make_symbol_reference(&symbol_set[Spelling]);
	    if (debug & DEBUG_INIT)
		print_symbols_by_ref(&symbol_set[Spelling]);
	    max_spell_length=max_left_context_length + max_rest_length;
	    if (!parse_only)
		prepare_spell();
	}
break;
case 59:
#line 615 "user.y"
{
	}
break;
case 60:
#line 620 "user.y"
{
	    defined_kind=Spelling;
	    max_left_context_length=0;
	    max_rest_length=0;
	}
break;
case 61:
#line 629 "user.y"
{
	    current_spell->left_context
		= reverse_chain(current_spell->left_context);
	    if (! has_concat_pos)
		current_spell->concat_pos = NO_CONCAT; /* impossible value */
	    defined_symbol=NULL; /* for error message */
	    max_left_context_length 
		= MAX(current_spell->left_context_length,
		      max_left_context_length);
	    max_rest_length 
		= MAX(current_spell->focus_length
		      + current_spell->right_context_length,
		      max_rest_length);
	    current_spell->constraint = yyvsp[0].chain;
	}
break;
case 62:
#line 647 "user.y"
{
	    defined_symbol = *new_symbol(yyvsp[0].string,&symbol_set[Spelling]);
	    current_spell
		= defined_symbol->data->spelling.instance;
	    current_spell->spell_link=defined_symbol;
	    /* next letter will be found in surface alphabet */
	    current_letter_kind=Surface_Letter;
	    current_letter_map=surface_letter_map;
	    current_pair_flags=BOTH_LETTERS; /* for next explicit Pair */
	    has_concat_pos=FALSE;
	    current_spell->concat_pos=0;
	    current_pattern=NULL; /* prepare for left context */
	    current_pattern_length=0;
	    within_focus=FALSE;
	}
break;
case 63:
#line 666 "user.y"
{

	}
break;
case 64:
#line 670 "user.y"
{

	}
break;
case 65:
#line 676 "user.y"
{
		current_spell->left_context=current_pattern;
		current_spell->left_context_length=current_pattern_length;
		if (has_concat_pos)
		    current_spell->concat_pos -= current_pattern_length;
		current_pattern=NULL; /* prepare for focus */
		current_pattern_length=0;
		within_focus=TRUE;
	    }
break;
case 66:
#line 688 "user.y"
{
		current_spell->right_context=current_pattern;
		current_spell->right_context_length=current_pattern_length;
	    }
break;
case 67:
#line 695 "user.y"
{
		current_spell->focus = current_pattern;
		current_spell->focus_length=current_pattern_length;
		if (! has_concat_pos)
		    current_spell->concat_pos += current_pattern_length;
		current_pattern = NULL; /* prepare for right context */
		current_pattern_length=0;
		within_focus=FALSE;
	    }
break;
case 68:
#line 707 "user.y"
{
	    current_spell->kind= Optional;
	}
break;
case 69:
#line 711 "user.y"
{
	    current_spell->kind= Obligatory;
	}
break;
case 70:
#line 715 "user.y"
{
	    current_spell->kind = Coerce;
	}
break;
case 71:
#line 722 "user.y"
{
	    yyval.chain = insert_chain_link(yyvsp[-1].chain, (t_ptr) yyvsp[0].tfs);
	    current_spell->constraint_card++;
	}
break;
case 72:
#line 727 "user.y"
{
	    current_spell->constraint_card = 0;
	    yyval.chain = NULL;
	}
break;
case 73:
#line 734 "user.y"
{
	    }
break;
case 74:
#line 737 "user.y"
{
	    }
break;
case 75:
#line 742 "user.y"
{
	    }
break;
case 76:
#line 745 "user.y"
{
	    }
break;
case 77:
#line 750 "user.y"
{
		if (has_concat_pos)
		    fatal_error("concatenation position already specified");
		has_concat_pos=TRUE;
		current_spell->concat_pos += current_pattern_length;
		current_pattern
		    = insert_chain_link(current_pattern,
					(t_ptr) morpheme_boundary_pair);
		current_pattern_length++;
	    }
break;
case 78:
#line 761 "user.y"
{
		current_pattern
		    = insert_chain_link(current_pattern,
					(t_ptr) morpheme_boundary_pair);
		current_pattern_length++;
	    }
break;
case 79:
#line 768 "user.y"
{
		current_pattern
		    = insert_chain_link(current_pattern,
					(t_ptr) word_boundary_pair);
		current_pattern_length++;
	    }
break;
case 80:
#line 775 "user.y"
{
		current_pattern
		    = insert_chain_link(current_pattern, (t_ptr) yyvsp[0].pair);
		current_pattern_length += lexical_width(yyvsp[0].pair);
	    }
break;
case 81:
#line 784 "user.y"
{
		}
break;
case 82:
#line 787 "user.y"
{
		}
break;
case 83:
#line 792 "user.y"
{

	}
break;
case 84:
#line 796 "user.y"
{
	}
break;
case 85:
#line 801 "user.y"
{
	}
break;
case 86:
#line 806 "user.y"
{
	    defined_kind = Lexicon;
	    variable_set=NULL; /* prevent variables in lexical Tfs */
	    variable_allowed=FALSE;
	    if ((db_operation & Update)) {
	 	/* options mentionned -a */
		augmenting=TRUE;
		initfile(augment_file_name); /* splice in file now */
	    }
	    /* otherwise splice it at the end of this file, cf tokenize.l */
	    /* tell tokenizer to interpret strings as lexical strings */
	    current_letter_kind=Lexical_Letter;
	    current_letter_map=lexical_letter_map;
	    normalize = normalize_flag;
	}
break;
case 87:
#line 824 "user.y"
{
	    free_tfs(common_tfs);
	    if (! parse_only) {
		map_chain(affix_tree_chain, free_affix_tree);
		free_chain(affix_tree_chain);
	    }
	}
break;
case 88:
#line 834 "user.y"
{
	    common_tfs = yyvsp[0].tfs;
	    if (! parse_only)
		affix_tree_chain = build_affix_trees(common_tfs);
	    else
		if (normalize) {
		    print_out("\t");
		    print_tfs1(outfile, common_tfs, FALSE, FALSE, FALSE);
		}
	  }
break;
case 89:
#line 847 "user.y"
{
	    }
break;
case 90:
#line 850 "user.y"
{
	    }
break;
case 91:
#line 855 "user.y"
{
	    parsing=FALSE;
	    if (! parse_only)
		generate_surface(current_string, current_base_form,
			         affix_tree_chain);
	    else
		if (normalize) {
		    print_out("\"");
		    print_string(outfile, current_string);
		    if (current_string != current_base_form
		        && strcmp((char *) current_string,
			          (char *) current_base_form)) {
			print_out("\" = \"");
			print_string(outfile, current_base_form);
		    }
		    print_out("\"\n");
		}
	    parsing=TRUE;
	    if (current_string != current_base_form)
		MY_FREE(current_base_form);
	    MY_FREE(current_string);
	}
break;
case 92:
#line 880 "user.y"
{
		/* TODO should not be in the lexical alphabet but user */
		current_base_form = yyvsp[0].letter_string;
	    }
break;
case 93:
#line 885 "user.y"
{
		current_base_form = current_string;
	    }
break;
case 94:
#line 891 "user.y"
{
	    /* save string */
	    current_string = yyvsp[0].letter_string;
	}
break;
case 95:
#line 897 "user.y"
{

	}
break;
case 96:
#line 901 "user.y"
{

	}
break;
case 97:
#line 907 "user.y"
{
		defined_symbol=NULL; /* end of definitions */
		allow_string_letters=FALSE;
	     }
break;
case 98:
#line 914 "user.y"
{
		t_str filler_symbol_name;

		defined_kind=Alphabet;
		init_symbol_set(&symbol_set[Pair], Lexical_Letter);
		/* fill the slot with ordinal number 0 with a dummy symbol
		   so that letter strings can also terminate with 0;
		   Use strdup, just in case the symbol is freed one day.
                 */
		MY_STRDUP(filler_symbol_name,""); /* impossible symbol name */
		(void) new_symbol(filler_symbol_name,&symbol_set[Pair]);
		/*  declare word boundary and morpheme boundary */
		MY_STRDUP(filler_symbol_name," + "); /* unlikely symbol name */
		morpheme_boundary_pair
		    = (s_pair *) (*new_symbol(filler_symbol_name,
				   &symbol_set[Pair]))->data;
		morpheme_boundary = morpheme_boundary_pair->lexical;
		/* tinker with the symbol table */
		morpheme_boundary_pair->surface= empty_string;
		first_lexical_letter=*morpheme_boundary;
		MY_STRDUP(filler_symbol_name," ~ "); /* unlikely symbol name */
		word_boundary_pair
		    = (s_pair *) (*new_symbol(filler_symbol_name,
				   &symbol_set[Pair]))->data;
		word_boundary=word_boundary_pair->lexical;
		/* tinker with the symbol table */
		word_boundary_pair->surface= empty_string;
		allow_string_letters=TRUE; /* allow ASTRING strings */
		MY_CALLOC(surface_letter_map,LETTER_MAP_SIZE,t_letter);
		MY_CALLOC(lexical_letter_map,LETTER_MAP_SIZE,t_letter);
		MY_CALLOC(letter_to_char_map,LETTER_MAP_SIZE,unsigned char);
		crc32file_addn(&crc, (unsigned char *) "@Alphabets ",
		               sizeof("@Alphabets "));
	     }
break;
case 99:
#line 951 "user.y"
{
		MY_FREE(fake_symbol.name);
		alphabet_size=symbol_set[Pair].card;
		make_symbol_reference(&symbol_set[Pair]);
		if (debug & DEBUG_INIT) {
		    print_symbols_by_ref(&symbol_set[Pair]);
		}
	     }
break;
case 100:
#line 962 "user.y"
{
		/* don't care about name, first is lexical, second surface */
		fake_symbol.name=yyvsp[0].string;
		fake_symbol.ordinal=0;
		defined_symbol=&fake_symbol;
		symbol_set[Pair].kind = Lexical_Letter;
		current_letter_map=lexical_letter_map;
		crc32file_addn(&crc, (unsigned char *) "Lexical:",
			       sizeof("Lexical:"));
	     }
break;
case 101:
#line 975 "user.y"
{
		/* don't care about name, first is lexical, second surface */
		defined_kind=Alphabet;
		MY_FREE(fake_symbol.name);
		fake_symbol.name=yyvsp[0].string;
		fake_symbol.ordinal=0;
		symbol_set[Pair].kind = Surface_Letter;
		current_letter_map=surface_letter_map;
		lexical_alphabet_size=symbol_set[Pair].card;
		crc32file_addn(&crc, (unsigned char *) "Surface:",
			       sizeof("Surface:"));
	     }
break;
case 102:
#line 990 "user.y"
{
	    }
break;
case 103:
#line 993 "user.y"
{
	    }
break;
case 104:
#line 998 "user.y"
{
		s_symbol *symbol;
		int	  length;

		symbol= *new_symbol(yyvsp[0].string,&symbol_set[Pair]);
		if ((length = strlen(symbol->name)) == 1) {
		    current_letter_map[(unsigned char) *symbol->name]
			    = (t_letter) symbol->ordinal;
		    letter_to_char_map[symbol->ordinal]
			    = (unsigned char) *symbol->name;
		}
		crc32file_addn(&crc, (unsigned char *) yyvsp[0].string , (int) length);
		crc32file_add(&crc, (unsigned char) ' ');
	    }
break;
case 105:
#line 1013 "user.y"
{ 	/* allow special characters to be declared  as letter */
		/* TODO: cleanup the cases where this name could be printed */
		s_symbol *symbol;
		
		symbol= *new_symbol(yyvsp[0].string,&symbol_set[Pair]);
		if (strlen(symbol->name) != 1)
			fatal_error("%s %s %s",
			    "Sorry: cannot accept string definition of",
			    symbol_kind_str[current_letter_kind],
			    "longer than one character");
		 else {
		    current_letter_map[(unsigned char) *symbol->name]
			    = (t_letter) symbol->ordinal;
		    letter_to_char_map[symbol->ordinal]
			    = (unsigned char) *symbol->name;
		}
		crc32file_add(&crc, (unsigned char) '"');
		crc32file_add(&crc, (unsigned char) *yyvsp[0].string);
		crc32file_add(&crc, (unsigned char) '"');
	    }
break;
case 106:
#line 1036 "user.y"
{
		defined_symbol=NULL; /* end of definitions */
		    if (debug & DEBUG_INIT) { /* TODO change this */
			print_symbol_table(&symbol_set[Pair]);
		    }
		MY_FREE(current_lexical_set);
	    }
break;
case 107:
#line 1044 "user.y"
{
	    }
break;
case 108:
#line 1049 "user.y"
{
		defined_kind=Pair;
		symbol_set[Pair].kind = Pair; 
		current_lexical_set=new_bitmap((long) alphabet_size);
	    }
break;
case 109:
#line 1057 "user.y"
{
		
	    }
break;
case 110:
#line 1061 "user.y"
{
	    }
break;
case 111:
#line 1066 "user.y"
{
		defined_symbol=NULL; /* for error message */
	    }
break;
case 112:
#line 1072 "user.y"
{
		defined_symbol = *new_symbol(yyvsp[0].string,&symbol_set[Pair]);

		current_pair = (s_pair *) defined_symbol->data;
		/* next letter will be found in surface alphabet */
		current_letter_kind=Surface_Letter;
		current_letter_map=surface_letter_map;
		current_pair_flags=BOTH_LETTERS; /* for next explicit Pair */
		empty_bitmap(current_lexical_set);
		current_pair_width=-1;
	    }
break;
case 113:
#line 1086 "user.y"
{
	    }
break;
case 114:
#line 1089 "user.y"
{
	    }
break;
case 115:
#line 1094 "user.y"
{
		int lexical_width;

		if (current_pair_flags & LEXICAL_IS_CLASS)
		    lexical_width=1;
		else 
		    lexical_width=strlen((char *) yyvsp[0].letter_string);
		if (lexical_width > 1) { /* TODO: print pair */
		    fatal_error("%s\nthe lexical part %s",
			    "Sorry, not yet implemented.", 
			    "of the pair cannot be longer than one symbol");
		}
		if (current_pair_width == -1)
		    current_pair_width = lexical_width;
		else
		    if (current_pair_width != lexical_width)
			fatal_error("%s %s",
				    "you cannot mix pairs with different",
				    "lexical lengths");
		if (lexical_width==0
		    && !(current_pair_flags & SURFACE_IS_CLASS)
		    && *(yyvsp[-2].letter_string) == NUL_LETTER)
		    fatal_error("empty pair <>/<> is not allowed");
		add_explicit_pair(current_pair,yyvsp[-2].letter_string,yyvsp[0].letter_string,current_pair_flags,
				  current_lexical_set);
		current_pair_flags=BOTH_LETTERS; /* restore for next */
	    }
break;
case 116:
#line 1122 "user.y"
{
		int pair_width;

		/* TODO factorize this code and similar above */
		if (yyvsp[0].symbol == defined_symbol)
		    fatal_error("pair name is used in its own definition");
		pair_width=lexical_width((s_pair *) yyvsp[0].symbol->data);
		if (current_pair_width == -1)
		    current_pair_width = pair_width;
		else
		    if (current_pair_width != pair_width)
			fatal_error("%s %s",
				    "you cannot mix pairs with different",
				    "lexical lengths");
		add_pair(current_pair, (s_pair *) yyvsp[0].symbol->data,
			 current_lexical_set);
	    }
break;
case 117:
#line 1142 "user.y"
{ /* similar to Pair above */
		int lexical_width;

		if (! (current_pair_flags & LEXICAL_IS_CLASS)) {
		    lexical_width=strlen((char *) yyvsp[0].letter_string);
		    if (lexical_width > 1) /* TODO: print pair */
			fatal_error("%s\nthe lexical part of th pair %s",
				"Sorry, not yet implemented.", 
				"cannot be longer than one symbol");
		    else
			if (lexical_width == 0
			    && ! (current_pair_flags & LEXICAL_IS_CLASS)
			    && *(yyvsp[-2].letter_string) == NUL_LETTER)
			    fatal_error("empty pair <>/<> is not allowed");
		}
		yyval.pair=new_pair(yyvsp[-2].letter_string,yyvsp[0].letter_string,current_pair_flags,(s_pair *) NULL);
		if (within_focus)
		    is_pair_concrete(yyval.pair);
		current_pair_flags=BOTH_LETTERS; /* restore for next */
	    }
break;
case 118:
#line 1163 "user.y"
{
		yyval.pair= (s_pair *) yyvsp[0].symbol->data;
		if (within_focus)
		    is_pair_concrete(yyval.pair);
	    }
break;
case 119:
#line 1172 "user.y"
{
		yyval.symbol= *find_symbol(yyvsp[0].string,&symbol_set[Pair]);
		if (! (yyval.symbol->kind == Pair
		       || yyval.symbol->kind == Pair_Letter
		       || yyval.symbol->kind == Pair_Class))
		    fatal_error("%s \"%s\"",
				"There is no pair associated to symbol",
				yyval.symbol->name);
	    }
break;
case 120:
#line 1184 "user.y"
{
		current_letter_kind=Lexical_Letter; /* alternate */
		current_letter_map=lexical_letter_map;
		yyval.letter_string=yyvsp[0].letter_string;
	    }
break;
case 121:
#line 1192 "user.y"
{
		current_letter_kind=Surface_Letter; /* alternate */
		current_letter_map=surface_letter_map;
		yyval.letter_string=yyvsp[0].letter_string;
	    }
break;
case 122:
#line 1200 "user.y"
{
		letter_string[letter_string_size]= NUL_LETTER;
		MY_STRDUP(yyval.letter_string,letter_string);
	    }
break;
case 123:
#line 1205 "user.y"
{
		yyval.letter_string= (t_letter *) yyvsp[0].letter_string;
	    }
break;
case 124:
#line 1209 "user.y"
{
		s_symbol   *pair_symbol;

		pair_symbol = *find_symbol(yyvsp[0].string, &symbol_set[Pair]);
		if (pair_symbol->kind== Pair
		    || (current_letter_kind == Surface_Letter
			&& (pair_symbol->kind == Lexical_Letter
			    || pair_symbol->kind == Lexical_Class))
		    || (current_letter_kind == Lexical_Letter
			&& (pair_symbol->kind == Surface_Letter
			    || pair_symbol->kind == Surface_Class)))
		    fatal_error("symbol \"%s\" is not a %s",
				pair_symbol->name,
				symbol_kind_str[current_letter_kind]);
		if (pair_symbol->data->pair.pair_flags == BOTH_CLASSES)
		    if (current_letter_kind == Surface_Letter)
			current_pair_flags |= SURFACE_IS_CLASS;
		    else
			current_pair_flags |= LEXICAL_IS_CLASS;
		if (current_letter_kind == Surface_Letter)
		    yyval.letter_string = pair_symbol->data->pair.surface;
		else
		    yyval.letter_string = pair_symbol->data->pair.lexical;
	    }
break;
case 125:
#line 1234 "user.y"
{
		yyval.letter_string = letter_any;
	    }
break;
case 126:
#line 1240 "user.y"
{
		if (letter_string_size >= LETTER_STRING_SIZE_MAX - 1)
		    fatal_error("symbol sequence too long, maximum=%d",
				LETTER_STRING_SIZE_MAX - 1);
		letter_string[letter_string_size++]
		    = *find_letter(yyvsp[0].string, current_letter_kind);
	    }
break;
case 127:
#line 1248 "user.y"
{
		letter_string_size=0;
	    }
break;
case 128:
#line 1255 "user.y"
{
		    defined_symbol=NULL; /* end of definitions */
		    allow_string_letters=FALSE;
		    if (debug & DEBUG_INIT) { /* TODO change this */
			print_symbol_table(&symbol_set[Pair]);
		    }
		}
break;
case 129:
#line 1263 "user.y"
{
		}
break;
case 130:
#line 1267 "user.y"
{
		defined_kind=Pair_Class;
		symbol_set[Pair].kind = Pair_Class;
		allow_string_letters=TRUE;
	    }
break;
case 131:
#line 1275 "user.y"
{
	    }
break;
case 132:
#line 1278 "user.y"
{
	    }
break;
case 133:
#line 1283 "user.y"
{
		if (class_flags & SURFACE_FLAG)
		    if (class_flags & LEXICAL_FLAG) {
			defined_symbol->kind=Pair_Class;
			defined_symbol->data->class.lexical = current_class;
		    }
		    else
			defined_symbol->kind=Surface_Class;
		else {
		    defined_symbol->kind = Lexical_Class;
		    defined_symbol->data->class.lexical = current_class;
		    defined_symbol->data->class.surface = NULL;
		}
		defined_symbol=NULL; /* for error message */
	    }
break;
case 134:
#line 1301 "user.y"
{
		defined_symbol = *new_symbol(yyvsp[0].string,&symbol_set[Pair]);
		current_class = defined_symbol->data->class.surface;
		class_flags = SURFACE_FLAG | LEXICAL_FLAG;
	    }
break;
case 135:
#line 1309 "user.y"
{
	    }
break;
case 136:
#line 1312 "user.y"
{
	    }
break;
case 137:
#line 1317 "user.y"
{
	  s_symbol *class_symbol;

	  class_symbol = *find_symbol(yyvsp[0].string,&symbol_set[Pair]);
	  switch (class_symbol->kind) {
	      case Surface_Letter:
		      class_flags &= SURFACE_FLAG;
		      set_bit(current_class,
			      (long) *(class_symbol->data->pair.surface));
		      break;
	      case Lexical_Letter:
		      class_flags &= LEXICAL_FLAG;
	      /*FALLTHROUGH*/
	      case Pair_Letter:
		      set_bit(current_class,
			      (long) *(class_symbol->data->pair.lexical));
		      break;
	      case Surface_Class:
		      class_flags &= SURFACE_FLAG;
		      assign_or(current_class,
				class_symbol->data->class.surface);
		      break;
	      case Lexical_Class:
		      class_flags &= LEXICAL_FLAG;
	      /*FALLTHROUGH*/
	      case Pair_Class:
		      if (class_symbol == defined_symbol)
			fatal_error(
			"symbol class is used in its own definition");
		      assign_or(current_class,
				class_symbol->data->class.lexical);
		      break;
	      default:
		      fatal_error("program bug: no such class kind");
		      break;	
	  }
	  if (class_flags == 0)
		fatal_error("you cannot mix %s (class=\"%s\", symbol=\"%s\")",
			    "pure lexical and surface symbols in same class",
			    defined_symbol->name,
			    class_symbol->name);
      }
break;
case 138:
#line 1360 "user.y"
{ /* allow special characters to be used as a class definition */
	/* TODO: cleanup the cases where this name could be printed ?? */
	s_symbol *class_symbol;

	class_symbol= *find_symbol(yyvsp[0].string,&symbol_set[Pair]);
	switch (class_symbol->kind) {
	    case Surface_Letter:
		    class_flags &= SURFACE_FLAG;
		    set_bit(current_class,
			    (long) *(class_symbol->data->pair.surface));
		    break;
	    case Lexical_Letter:
		    class_flags &= LEXICAL_FLAG;
	    /*FALLTHROUGH*/
	    case Pair_Letter:
		    set_bit(current_class,
			    (long) *(class_symbol->data->pair.lexical));
		    break;
	    default:
		    fatal_error("program bug: no such class kind");
		    break;	
	}
	if (class_flags == 0)
	      fatal_error("%s %s (class=\"%s\", symbol=\"%s\")",
			  "you cannot mix pure lexical and surface",
			  "symbols in the same class",
			  defined_symbol->name,
			  class_symbol->name);
      }
break;
#line 1962 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
